<?php 
    header("Content-Type:text/xml; charset=utf-8");
    // PROCE55.COM - PHP demonstration of request/response processing in EastGate PROCE55 applications
    // Copyright 2015 EastGate [www.east-gate.eu]
    
    // Read the client XML request from the HTTP POST and build the XML DOM document:
    // Sample request:
    
    // The initial XML processing instruction is added to conform to the XML DOM specification:
    $input = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" . trim(file_get_contents("php://input"));
    
    $dom = new DOMDocument;
    $dom->preserveWhiteSpace = false;
    $dom->loadXML($input,LIBXML_NOERROR);

    $php_ver = phpversion();
    $cur_time = time();

    // -------------------------- Do something with the request data in $dom:  ---------------------------- 
    // ...
    // ...
    
    
    // -------------------------- Build the XML_HTTP response message: --------------------------------------------- 
    
    if ($_REQUEST['mode'] == "JSON" || $_REQUEST['mode'] == "json") {
    
    $response = '{
    "TABLE1":[{
                "ID":"111",
                "MATNR":"9157821211",
                "TEXT":"Test material 111"
              },
              {
                "ID":"222",
                "MATNR":"9157821212",
                "TEXT":"Test material 222"
              },
              {
                "ID":"333",
                "MATNR":"9157821213",
                "TEXT":"Test material 333"
              }
            ],
        
    "scalars":[{
                "MATNR":"0987654321",
                "TEXT":"Test material text",
                "PHPVER":"PHP 5.6"
              }]
    }';
    
    }
    else {
    
    // Start of the response message:
    $response =  "<XML_HTTP><XML_HTTP_RESPONSE>";
    
    // Scalar parameters in response:
    $response .= "<RETURN_PARAMETERS>";
    $response .= "<MATNR>0987654321</MATNR>";
    $response .= "<TEXT>Test material text</TEXT>";
    $response .= "<PHPVER>PHP $php_ver ($cur_time)</PHPVER>";
    $response .= "</RETURN_PARAMETERS>";
    
    // Tables (can be multiple tables within the <TABLES></TABLES> block)
    $response .= "<TABLES>";
    
    // First line of a table (TABLE1)
    $response .= "<TABLE1>";
    $response .= "<ID>1111</ID>";
    $response .= "<MATNR>4687513202</MATNR>";
    $response .= "<TEXT>Material 1</TEXT>";
    $response .= "</TABLE1>";
    
    // Second line of a table (TABLE1)
    $response .= "<TABLE1>";
    $response .= "<ID>2222</ID>";
    $response .= "<MATNR>9157821211</MATNR>";
    $response .= "<TEXT>Material 2</TEXT>";
    $response .= "</TABLE1>";
    
    // End of tables:
    $response .= "</TABLES>";
    // End of the response structure:    
    $response .= "</XML_HTTP_RESPONSE></XML_HTTP>";
    
    }
    
    
    //$node = $dom->documentElement;
    //foreach ($node->childNodes AS $item) {
    //    print $item->nodeName . "=" . $item->nodeValue;
    //}
 
    //$function_node = $dom->getElementsByTagName( "FUNCTION" );
    //$function_name = $function_node->item(0)->nodeValue;
    
    //foreach( $books as $book )
    //{
    //$para = $book->getElementsByTagName( "INPUT" );
    //$author = $authors->item(0)->nodeValue;
  
    //$input_params = $dom->getElementsByTagName( "INPUT" );
    //$publisher = $publishers->item(0)->nodeValue;
  
    //$titles = $book->getElementsByTagName( "title" );
    //$title = $titles->item(0)->nodeValue;
  
    //echo "$title - $author - $publisher\n";
    //}


    // <XML_HTTP_REQUEST><FUNCTION NAME="Z_CHECK_COIL"><INPUT><TRNR VALUE="f259240030" /></INPUT></FUNCTION></XML_HTTP_REQUEST>
    // XML_HTTP request: <XML_HTTP_REQUEST><FUNCTION NAME="GET_TABLE_GROUP"><INPUT><MATNR>1234567890</MATNR></INPUT><TABLES></TABLES></FUNCTION></XML_HTTP_REQUEST>
    // <XML_HTTP_REQUEST><FUNCTION NAME="Z_CHECK_COIL"><INPUT><TRNR VALUE="f259240030" /></INPUT></FUNCTION></XML_HTTP_REQUEST>
    // <XML_HTTP_REQUEST><FUNCTION NAME="CREATE_GOODS_ISSUES"><INPUT><SCRAP VALUE="" /><LENGTH VALUE="500" /></INPUT><TABLES><FIELDS TABLE="REFERENCES" FIELD="ID" ROW="1" VALUE="32561"/><FIELDS TABLE="REFERENCES" FIELD="COIL" ROW="1" VALUE="19073"/><FIELDS TABLE="REFERENCES" FIELD="POSLENGTH" ROW="1" VALUE="1000"/><FIELDS TABLE="REFERENCES" FIELD="POSITION" ROW="1" VALUE="A"/><FIELDS TABLE="REFERENCES" FIELD="MATERIAL NUM." ROW="1" VALUE="10358700"/><FIELDS TABLE="REFERENCES" FIELD="MATERIALNAME" ROW="1" VALUE="A2XS(F)2Y  3X1X400 RM/25   12/20 KV   -T"/><FIELDS TABLE="REFERENCES" FIELD="ÄM-NR." ROW="1" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="TEXT" ROW="1" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="INFO" ROW="1" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="BEM." ROW="1" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="RV-CODE" ROW="1" VALUE="32561"/><FIELDS TABLE="REFERENCES" FIELD="WES (FREMDFERT.)" ROW="1" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="ID" ROW="2" VALUE="32564"/><FIELDS TABLE="REFERENCES" FIELD="COIL" ROW="2" VALUE="19039"/><FIELDS TABLE="REFERENCES" FIELD="POSLENGTH" ROW="2" VALUE="1010"/><FIELDS TABLE="REFERENCES" FIELD="POSITION" ROW="2" VALUE="A"/><FIELDS TABLE="REFERENCES" FIELD="MATERIAL NUM." ROW="2" VALUE="10358700"/><FIELDS TABLE="REFERENCES" FIELD="MATERIALNAME" ROW="2" VALUE="A2XS(F)2Y  3X1X400 RM/25   12/20 KV   -T"/><FIELDS TABLE="REFERENCES" FIELD="ÄM-NR." ROW="2" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="TEXT" ROW="2" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="INFO" ROW="2" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="BEM." ROW="2" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="RV-CODE" ROW="2" VALUE="32564"/><FIELDS TABLE="REFERENCES" FIELD="WES (FREMDFERT.)" ROW="2" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="ID" ROW="3" VALUE="32567"/><FIELDS TABLE="REFERENCES" FIELD="COIL" ROW="3" VALUE="19017"/><FIELDS TABLE="REFERENCES" FIELD="POSLENGTH" ROW="3" VALUE="1010"/><FIELDS TABLE="REFERENCES" FIELD="POSITION" ROW="3" VALUE="A"/><FIELDS TABLE="REFERENCES" FIELD="MATERIAL NUM." ROW="3" VALUE="10358700"/><FIELDS TABLE="REFERENCES" FIELD="MATERIALNAME" ROW="3" VALUE="A2XS(F)2Y  3X1X400 RM/25   12/20 KV   -T"/><FIELDS TABLE="REFERENCES" FIELD="ÄM-NR." ROW="3" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="TEXT" ROW="3" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="INFO" ROW="3" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="BEM." ROW="3" VALUE=""/><FIELDS TABLE="REFERENCES" FIELD="RV-CODE" ROW="3" VALUE="32567"/><FIELDS TABLE="REFERENCES" FIELD="WES (FREMDFERT.)" ROW="3" VALUE=""/></TABLES></FUNCTION></XML_HTTP_REQUEST>
    
    // table response:
    // <XML_HTTP><XML_HTTP_RESPONSE>
    // <RETURN_PARAMETERS>
    // <COIL>F1234</COIL>
    // <ID>9335</ID></RETURN_PARAMETERS>
    // <TABLES><HISTAB>
    // <WP></WP><QUANT>0</QUANT><COIL>28159</COIL><POSITION>A</POSITION>
    // <ID>9175</ID><DT>6.5.2011 16:17</DT><AEM></AEM><PA></PA><REM></REM>
    // </HISTAB>
    // <HISTAB><WP>LI 16</WP><QUANT>0</QUANT><COIL>REPAIR</COIL>
    // .... </HISTAB></TABLES>
    // </XML_HTTP_RESPONSE></XML_HTTP>
                                     
    // XML_HTTP response: <XML_HTTP><XML_HTTP_RESPONSE><TABLES>
    //<TABLEDATA>
    //<DELETED>N</DELETED>
    //<NAME>1</NAME>
    //<PROCESS_ID>1</PROCESS_ID>
    //<TYPE>1</TYPE>
    //</TABLEDATA>
    //<TABLEDATA>
    //<DELETED>N</DELETED>
    //<NAME>2</NAME>
    //<PROCESS_ID>1</PROCESS_ID>
    //<TYPE>2</TYPE>
    //</TABLEDATA>
    //</TABLES></XML_HTTP_RESPONSE></XML_HTTP>
    
    // <XML_HTTP><XML_HTTP_RESPONSE><RETURN_PARAMETERS><STATUS>ERROR</STATUS><INFO>Could not connect to the server.</INFO></RETURN_PARAMETERS></XML_HTTP_RESPONSE></XML_HTTP>
    
    //echo "$in";
 
    //while($in = fgets(STDIN)){
    // echo "line: $f=in";
    //}
 
    //echo '<p>Hello World</p>'; 
 

      //echo $input->asXML();
      //echo $xml->asXML();
    
    
    // ---------------------- Return the response to the client: ---------------------------- 
    echo "$response";
  ?>  